Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/bd/vbd/disk.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2016 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -51,4 +51,6 @@
 #include "types/vbd.h"
 
+loc_srv_t *vbds_srv;
+
 static fibril_mutex_t vbds_disks_lock;
 static list_t vbds_disks; /* of vbds_disk_t */
@@ -497,5 +499,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "block_init(%zu)", sid);
-	rc = block_init(sid, 2048);
+	rc = block_init(sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed opening block device %s.",
@@ -1122,5 +1124,5 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "loc_service_register('%s')",
 	    name);
-	rc = loc_service_register(name, &psid);
+	rc = loc_service_register(vbds_srv, name, &psid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering "
@@ -1131,5 +1133,5 @@
 	}
 
-	rc = loc_service_add_to_cat(psid, part_cid);
+	rc = loc_service_add_to_cat(vbds_srv, psid, part_cid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failled adding partition "
@@ -1138,5 +1140,5 @@
 		free(part);
 
-		rc = loc_service_unregister(psid);
+		rc = loc_service_unregister(vbds_srv, psid);
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Error unregistering "
@@ -1160,5 +1162,5 @@
 	    "disk->svc_name='%s', id=%zu)", part->disk->svc_name, part->svc_id);
 
-	rc = loc_service_unregister(part->svc_id);
+	rc = loc_service_unregister(vbds_srv, part->svc_id);
 	if (rc != EOK)
 		return EIO;
Index: uspace/srv/bd/vbd/disk.h
===================================================================
--- uspace/srv/bd/vbd/disk.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/bd/vbd/disk.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -57,4 +57,6 @@
 extern void vbds_bd_conn(ipc_call_t *, void *);
 
+extern loc_srv_t *vbds_srv;
+
 #endif
 
Index: uspace/srv/bd/vbd/vbd.c
===================================================================
--- uspace/srv/bd/vbd/vbd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/bd/vbd/vbd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -68,5 +68,5 @@
 	async_set_fallback_port_handler(vbds_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &vbds_srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -74,5 +74,5 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_VBD, &ctl_sid);
+	rc = loc_service_register(vbds_srv, SERVICE_NAME_VBD, &ctl_sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/clipboard/clipboard.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2009 Martin Decky
  * All rights reserved.
@@ -185,9 +186,10 @@
 {
 	errno_t rc;
+	loc_srv_t *srv;
 
 	printf("%s: HelenOS clipboard service\n", NAME);
 	async_set_fallback_port_handler(clip_connection, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Failed registering server: %s\n", NAME, str_error(rc));
@@ -195,6 +197,8 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_CLIPBOARD, &svc_id);
+	rc = loc_service_register(srv, SERVICE_NAME_CLIPBOARD, &svc_id);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
+
 		printf("%s: Failed registering service : %s\n", NAME, str_error(rc));
 		return rc;
Index: uspace/srv/clipboard/meson.build
===================================================================
--- uspace/srv/clipboard/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/clipboard/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -28,3 +29,4 @@
 #
 
+deps = [ 'clipboard' ]
 src = files('clipboard.c')
Index: uspace/srv/devman/devtree.c
===================================================================
--- uspace/srv/devman/devtree.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/devman/devtree.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -93,5 +93,5 @@
 }
 
-static hash_table_ops_t devman_devices_ops = {
+static const hash_table_ops_t devman_devices_ops = {
 	.hash = devman_devices_hash,
 	.key_hash = handle_key_hash,
@@ -101,5 +101,5 @@
 };
 
-static hash_table_ops_t devman_functions_ops = {
+static const hash_table_ops_t devman_functions_ops = {
 	.hash = devman_functions_hash,
 	.key_hash = handle_key_hash,
@@ -109,5 +109,5 @@
 };
 
-static hash_table_ops_t loc_devices_ops = {
+static const hash_table_ops_t loc_devices_ops = {
 	.hash = loc_functions_hash,
 	.key_hash = service_id_key_hash,
Index: uspace/srv/devman/drv_conn.c
===================================================================
--- uspace/srv/devman/drv_conn.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/devman/drv_conn.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -360,5 +361,5 @@
 	rc = loc_category_get_id(cat_name, &cat_id, IPC_FLAG_BLOCKING);
 	if (rc == EOK)
-		rc = loc_service_add_to_cat(fun->service_id, cat_id);
+		rc = loc_service_add_to_cat(devman_srv, fun->service_id, cat_id);
 	if (rc == EOK) {
 		log_msg(LOG_DEFAULT, LVL_NOTE, "Function `%s' added to category `%s'.",
Index: uspace/srv/devman/loc.c
===================================================================
--- uspace/srv/devman/loc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/devman/loc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -37,4 +38,5 @@
 #include "fun.h"
 #include "loc.h"
+#include "main.h"
 
 /** Create loc path and name for the function. */
@@ -59,5 +61,5 @@
 	}
 
-	loc_service_register(loc_pathname, &fun->service_id);
+	loc_service_register(devman_srv, loc_pathname, &fun->service_id);
 
 	tree_add_loc_function(tree, fun);
@@ -69,5 +71,5 @@
 errno_t loc_unregister_tree_function(fun_node_t *fun, dev_tree_t *tree)
 {
-	errno_t rc = loc_service_unregister(fun->service_id);
+	errno_t rc = loc_service_unregister(devman_srv, fun->service_id);
 	tree_rem_loc_function(tree, fun);
 	return rc;
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/devman/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -64,4 +65,5 @@
 driver_list_t drivers_list;
 dev_tree_t device_tree;
+loc_srv_t *devman_srv;
 
 static void devman_connection_device(ipc_call_t *icall, void *arg)
@@ -280,4 +282,6 @@
 static bool devman_init(void)
 {
+	errno_t rc;
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "devman_init - looking for available drivers.");
 
@@ -305,5 +309,9 @@
 	 * not work.
 	 */
-	loc_server_register(NAME);
+	rc = loc_server_register(NAME, &devman_srv);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_FATAL, "Error registering devman server.");
+		return false;
+	}
 
 	return true;
Index: uspace/srv/devman/main.h
===================================================================
--- uspace/srv/devman/main.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/devman/main.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,8 +34,10 @@
 #define MAIN_H_
 
+#include <loc.h>
 #include "devman.h"
 
 extern driver_list_t drivers_list;
 extern dev_tree_t device_tree;
+extern loc_srv_t *devman_srv;
 
 #endif
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -323,5 +324,5 @@
 
 /** Nodes hash table operations */
-static hash_table_ops_t nodes_ops = {
+static const hash_table_ops_t nodes_ops = {
 	.hash = nodes_hash,
 	.key_hash = nodes_key_hash,
@@ -1093,5 +1094,5 @@
 
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
@@ -1150,5 +1151,5 @@
 {
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/exfat/exfat_idx.c
===================================================================
--- uspace/srv/fs/exfat/exfat_idx.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/exfat/exfat_idx.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -149,5 +149,5 @@
 }
 
-static hash_table_ops_t uph_ops = {
+static const hash_table_ops_t uph_ops = {
 	.hash = pos_hash,
 	.key_hash = pos_key_hash,
@@ -195,5 +195,5 @@
 }
 
-static hash_table_ops_t uih_ops = {
+static const hash_table_ops_t uih_ops = {
 	.hash = idx_hash,
 	.key_hash = idx_key_hash,
Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2011 Oleg Romanenko
@@ -1020,5 +1021,5 @@
 
 	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/fat/fat_idx.c
===================================================================
--- uspace/srv/fs/fat/fat_idx.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/fat/fat_idx.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -149,5 +149,5 @@
 }
 
-static hash_table_ops_t uph_ops = {
+static const hash_table_ops_t uph_ops = {
 	.hash = pos_hash,
 	.key_hash = pos_key_hash,
@@ -195,5 +195,5 @@
 }
 
-static hash_table_ops_t uih_ops = {
+static const hash_table_ops_t uih_ops = {
 	.hash = idx_hash,
 	.key_hash = idx_key_hash,
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2011 Oleg Romanenko
@@ -839,5 +840,5 @@
 service_id_t fat_service_get(fs_node_t *fn)
 {
-	return FAT_NODE(fn)->idx->service_id;
+	return 0;
 }
 
@@ -916,5 +917,5 @@
 
 	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/locfs/locfs_ops.c
===================================================================
--- uspace/srv/fs/locfs/locfs_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/locfs/locfs_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -95,5 +95,5 @@
 }
 
-static hash_table_ops_t services_ops = {
+static const hash_table_ops_t services_ops = {
 	.hash = services_hash,
 	.key_hash = services_key_hash,
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Maurizio Lombardi
  * All rights reserved.
@@ -123,5 +124,5 @@
 }
 
-static hash_table_ops_t open_nodes_ops = {
+static const hash_table_ops_t open_nodes_ops = {
 	.hash = open_nodes_hash,
 	.key_hash = open_nodes_key_hash,
@@ -283,5 +284,5 @@
 
 	/* Initialize libblock */
-	rc = block_init(service_id, 4096);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
@@ -310,5 +311,5 @@
 
 	/* Initialize libblock */
-	rc = block_init(service_id, 4096);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
@@ -392,6 +393,5 @@
 mfs_service_get(fs_node_t *fsnode)
 {
-	struct mfs_node *node = fsnode->data;
-	return node->instance->service_id;
+	return 0;
 }
 
Index: uspace/srv/fs/tmpfs/tmpfs_ops.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -189,5 +189,5 @@
 
 /** TMPFS nodes hash table operations. */
-hash_table_ops_t nodes_ops = {
+const hash_table_ops_t nodes_ops = {
 	.hash = nodes_hash,
 	.key_hash = nodes_key_hash,
Index: uspace/srv/fs/udf/udf.h
===================================================================
--- uspace/srv/fs/udf/udf.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/udf/udf.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2012 Julia Medvedeva
@@ -51,6 +52,4 @@
 
 #define BS_BLOCK     0
-#define MIN_SIZE     512
-#define MAX_SIZE     8192
 #define DEFAULT_VOL  0
 
Index: uspace/srv/fs/udf/udf_idx.c
===================================================================
--- uspace/srv/fs/udf/udf_idx.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/udf/udf_idx.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -78,5 +78,5 @@
 }
 
-static hash_table_ops_t udf_idx_ops = {
+static const hash_table_ops_t udf_idx_ops = {
 	.hash = udf_idx_hash,
 	.key_hash = udf_idx_key_hash,
Index: uspace/srv/fs/udf/udf_ops.c
===================================================================
--- uspace/srv/fs/udf/udf_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/fs/udf/udf_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2012 Julia Medvedeva
@@ -104,8 +105,4 @@
 static service_id_t udf_service_get(fs_node_t *node)
 {
-	udf_node_t *udfn = UDF_NODE(node);
-	if (udfn)
-		return udfn->instance->service_id;
-
 	return 0;
 }
@@ -327,5 +324,5 @@
 
 	/* initialize block cache */
-	errno_t rc = block_init(service_id, MAX_SIZE);
+	errno_t rc = block_init(service_id);
 	if (rc != EOK) {
 		free(instance);
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/console/console.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -37,4 +37,5 @@
 #include <stdio.h>
 #include <adt/prodcons.h>
+#include <io/console.h>
 #include <io/input.h>
 #include <ipc/vfs.h>
@@ -89,4 +90,6 @@
 } console_t;
 
+static loc_srv_t *console_srv;
+
 /** Input server proxy */
 static input_t *input;
@@ -120,8 +123,11 @@
 static errno_t input_ev_active(input_t *);
 static errno_t input_ev_deactive(input_t *);
-static errno_t input_ev_key(input_t *, kbd_event_type_t, keycode_t, keymod_t, char32_t);
-static errno_t input_ev_move(input_t *, int, int);
-static errno_t input_ev_abs_move(input_t *, unsigned, unsigned, unsigned, unsigned);
-static errno_t input_ev_button(input_t *, int, int);
+static errno_t input_ev_key(input_t *, unsigned, kbd_event_type_t, keycode_t,
+    keymod_t, char32_t);
+static errno_t input_ev_move(input_t *, unsigned, int, int);
+static errno_t input_ev_abs_move(input_t *, unsigned, unsigned, unsigned,
+    unsigned, unsigned);
+static errno_t input_ev_button(input_t *, unsigned, int, int);
+static errno_t input_ev_dclick(input_t *, unsigned, int);
 
 static input_ev_ops_t input_ev_ops = {
@@ -131,5 +137,6 @@
 	.move = input_ev_move,
 	.abs_move = input_ev_abs_move,
-	.button = input_ev_button
+	.button = input_ev_button,
+	.dclick = input_ev_dclick
 };
 
@@ -149,4 +156,5 @@
 static void cons_set_rgb_color(con_srv_t *, pixel_t, pixel_t);
 static void cons_set_cursor_visibility(con_srv_t *, bool);
+static errno_t cons_set_caption(con_srv_t *, const char *);
 static errno_t cons_get_event(con_srv_t *, cons_event_t *);
 static errno_t cons_map(con_srv_t *, sysarg_t, sysarg_t, charfield_t **);
@@ -170,4 +178,5 @@
 	.set_rgb_color = cons_set_rgb_color,
 	.set_cursor_visibility = cons_set_cursor_visibility,
+	.set_caption = cons_set_caption,
 	.get_event = cons_get_event,
 	.map = cons_map,
@@ -353,11 +362,17 @@
 }
 
-static errno_t input_ev_key(input_t *input, kbd_event_type_t type, keycode_t key,
-    keymod_t mods, char32_t c)
+static errno_t input_ev_key(input_t *input, unsigned kbd_id,
+    kbd_event_type_t type, keycode_t key, keymod_t mods, char32_t c)
 {
 	cons_event_t event;
-
+	bool alt;
+	bool shift;
+
+	alt = (mods & KM_ALT) != 0 && (mods & (KM_CTRL | KM_SHIFT)) == 0;
+	shift = (mods & KM_SHIFT) != 0 && (mods & (KM_CTRL | KM_ALT)) == 0;
+
+	/* Switch console on Alt+Fn or Shift+Fn */
 	if ((key >= KC_F1) && (key <= KC_F1 + CONSOLE_COUNT) &&
-	    ((mods & KM_CTRL) == 0)) {
+	    (alt || shift)) {
 		cons_switch(key - KC_F1);
 	} else {
@@ -365,4 +380,5 @@
 		event.type = CEV_KEY;
 
+		(void)kbd_id;
 		event.ev.key.type = type;
 		event.ev.key.key = key;
@@ -413,23 +429,44 @@
 }
 
-static errno_t input_ev_move(input_t *input, int dx, int dy)
-{
+static errno_t input_ev_move(input_t *input, unsigned pos_id, int dx, int dy)
+{
+	(void) pos_id;
 	pointer_update(pointer_x + dx, pointer_y + dy);
 	return EOK;
 }
 
-static errno_t input_ev_abs_move(input_t *input, unsigned x, unsigned y,
-    unsigned max_x, unsigned max_y)
-{
+static errno_t input_ev_abs_move(input_t *input, unsigned pos_id, unsigned x,
+    unsigned y, unsigned max_x, unsigned max_y)
+{
+	(void)pos_id;
 	pointer_update(mouse_scale_x * cols * x / max_x, mouse_scale_y * rows * y / max_y);
 	return EOK;
 }
 
-static errno_t input_ev_button(input_t *input, int bnum, int bpress)
+static errno_t input_ev_button(input_t *input, unsigned pos_id, int bnum,
+    int bpress)
 {
 	cons_event_t event;
+
+	(void)pos_id;
 
 	event.type = CEV_POS;
 	event.ev.pos.type = bpress ? POS_PRESS : POS_RELEASE;
+	event.ev.pos.btn_num = bnum;
+	event.ev.pos.hpos = pointer_x / mouse_scale_x;
+	event.ev.pos.vpos = pointer_y / mouse_scale_y;
+
+	console_queue_cons_event(active_console, &event);
+	return EOK;
+}
+
+static errno_t input_ev_dclick(input_t *input, unsigned pos_id, int bnum)
+{
+	cons_event_t event;
+
+	(void)pos_id;
+
+	event.type = CEV_POS;
+	event.ev.pos.type = POS_DCLICK;
 	event.ev.pos.btn_num = bnum;
 	event.ev.pos.hpos = pointer_x / mouse_scale_x;
@@ -653,4 +690,13 @@
 }
 
+static errno_t cons_set_caption(con_srv_t *srv, const char *caption)
+{
+	console_t *cons = srv_to_console(srv);
+
+	(void) cons;
+	(void) caption;
+	return EOK;
+}
+
 static errno_t cons_get_event(con_srv_t *srv, cons_event_t *event)
 {
@@ -865,5 +911,5 @@
 	/* Register server */
 	async_set_fallback_port_handler(client_connection, NULL);
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &console_srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register server (%s)\n", NAME,
@@ -915,5 +961,6 @@
 			snprintf(vc, LOC_NAME_MAXLEN, "%s/vc%zu", NAMESPACE, i);
 
-			if (loc_service_register(vc, &consoles[i].dsid) != EOK) {
+			if (loc_service_register(console_srv, vc,
+			    &consoles[i].dsid) != EOK) {
 				printf("%s: Unable to register device %s\n", NAME, vc);
 				return false;
Index: uspace/srv/hid/console/meson.build
===================================================================
--- uspace/srv/hid/console/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/console/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'console', 'input', 'output' ]
 src = files('console.c')
Index: uspace/srv/hid/display/cfgclient.c
===================================================================
--- uspace/srv/hid/display/cfgclient.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/cfgclient.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,191 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server CFG client
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <io/log.h>
+#include <stdlib.h>
+#include "cfgclient.h"
+#include "display.h"
+#include "window.h"
+
+/** Create CFG client.
+ *
+ * @param display Parent display
+ * @param cb CFG client callbacks
+ * @param cb_arg Callback argument
+ * @param rcfgclient Place to store pointer to new CFG client.
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ds_cfgclient_create(ds_display_t *display, ds_cfgclient_cb_t *cb,
+    void *cb_arg, ds_cfgclient_t **rcfgclient)
+{
+	ds_cfgclient_t *cfgclient;
+
+	cfgclient = calloc(1, sizeof(ds_cfgclient_t));
+	if (cfgclient == NULL)
+		return ENOMEM;
+
+	list_initialize(&cfgclient->events);
+	cfgclient->cb = cb;
+	cfgclient->cb_arg = cb_arg;
+
+	ds_display_add_cfgclient(display, cfgclient);
+
+	*rcfgclient = cfgclient;
+	return EOK;
+}
+
+/** Destroy CFG client.
+ *
+ * @param cfgclient CFG client
+ */
+void ds_cfgclient_destroy(ds_cfgclient_t *cfgclient)
+{
+	ds_cfgclient_purge_events(cfgclient);
+	ds_display_remove_cfgclient(cfgclient);
+	free(cfgclient);
+}
+
+/** Get next event from CFG client event queue.
+ *
+ * @param cfgclient CFG client
+ * @param event Place to store event
+ * @return EOK on success, ENOENT if event queue is empty
+ */
+errno_t ds_cfgclient_get_event(ds_cfgclient_t *cfgclient, dispcfg_ev_t *event)
+{
+	link_t *link;
+	ds_cfgclient_ev_t *wevent;
+
+	link = list_first(&cfgclient->events);
+	if (link == NULL)
+		return ENOENT;
+
+	wevent = list_get_instance(link, ds_cfgclient_ev_t, levents);
+	list_remove(link);
+
+	*event = wevent->event;
+	free(wevent);
+	return EOK;
+}
+
+/** Purge events from CFG client event queue.
+ *
+ * @param client Client
+ */
+void ds_cfgclient_purge_events(ds_cfgclient_t *cfgclient)
+{
+	link_t *cur;
+	link_t *next;
+	ds_cfgclient_ev_t *wevent;
+
+	cur = list_first(&cfgclient->events);
+	while (cur != NULL) {
+		next = list_next(cur, &cfgclient->events);
+		wevent = list_get_instance(cur, ds_cfgclient_ev_t, levents);
+
+		list_remove(cur);
+		free(wevent);
+		cur = next;
+	}
+}
+
+/** Post seat added event to the CFG client's message queue.
+ *
+ * @param cfgclient CFG client
+ * @param seat_id Seat ID of the added seat
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_cfgclient_post_seat_added_event(ds_cfgclient_t *cfgclient,
+    sysarg_t seat_id)
+{
+	ds_cfgclient_ev_t *sevent;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "cfgclient_pos_seat_added_event "
+	    "cfgclient=%p seat_id=%zu\n", (void *)cfgclient, seat_id);
+
+	sevent = calloc(1, sizeof(ds_cfgclient_ev_t));
+	if (sevent == NULL)
+		return ENOMEM;
+
+	sevent->cfgclient = cfgclient;
+	sevent->event.etype = dcev_seat_added;
+	sevent->event.seat_id = seat_id;
+	list_append(&sevent->levents, &cfgclient->events);
+
+	/* Notify the client */
+	// TODO Do not send more than once until client drains the queue
+	if (cfgclient->cb != NULL && cfgclient->cb->ev_pending != NULL)
+		cfgclient->cb->ev_pending(cfgclient->cb_arg);
+
+	return EOK;
+}
+
+/** Post seat removed event to the CFG client's message queue.
+ *
+ * @param cfgclient CFG client
+ * @param seat_id Seat ID of the added seat
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_cfgclient_post_seat_removed_event(ds_cfgclient_t *cfgclient,
+    sysarg_t seat_id)
+{
+	ds_cfgclient_ev_t *sevent;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "cfgclient_pos_seat_removed_event "
+	    "cfgclient=%p seat_id=%zu\n", (void *)cfgclient, seat_id);
+
+	sevent = calloc(1, sizeof(ds_cfgclient_ev_t));
+	if (sevent == NULL)
+		return ENOMEM;
+
+	sevent->cfgclient = cfgclient;
+	sevent->event.etype = dcev_seat_removed;
+	sevent->event.seat_id = seat_id;
+	list_append(&sevent->levents, &cfgclient->events);
+
+	/* Notify the client */
+	// TODO Do not send more than once until client drains the queue
+	if (cfgclient->cb != NULL && cfgclient->cb->ev_pending != NULL)
+		cfgclient->cb->ev_pending(cfgclient->cb_arg);
+
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/display/cfgclient.h
===================================================================
--- uspace/srv/hid/display/cfgclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/cfgclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server CFG client
+ */
+
+#ifndef CFGCLIENT_H
+#define CFGCLIENT_H
+
+#include <errno.h>
+#include <dispcfg.h>
+#include "types/display/display.h"
+#include "types/display/cfgclient.h"
+
+extern errno_t ds_cfgclient_create(ds_display_t *, ds_cfgclient_cb_t *, void *,
+    ds_cfgclient_t **);
+extern void ds_cfgclient_destroy(ds_cfgclient_t *);
+extern errno_t ds_cfgclient_get_event(ds_cfgclient_t *, dispcfg_ev_t *);
+extern errno_t ds_cfgclient_post_seat_added_event(ds_cfgclient_t *, sysarg_t);
+extern errno_t ds_cfgclient_post_seat_removed_event(ds_cfgclient_t *, sysarg_t);
+extern void ds_cfgclient_purge_events(ds_cfgclient_t *);
+
+#endif
+
+/** @}
+ */
